﻿using System;
using System.Collections.Generic;

using System.Text;

using CppDepend.CodeModel;
namespace CustomCQLinqExtensions
{
    public static class CustomExtensions
    {
        
        /*
         * You can easily define add a new metric by adding an extension method 
         * The extension could be added to Application,Project,Type,Method and Field.
         * for example this custom metric could be used in the cqlinq queries like this:
         * from m in Methods where m.MyMetric>20 select m
         **/ 
        public static int MyMetric(this IMethod method)
        {
            int myCustomMetric = 0;
            //do some calculation

            return myCustomMetric;

        }
        /*
         * You can also define an extension to reuse some logic of your queries. 
         * For example get a set of methods with some conditions.
         * And it could be used in the cqlinq queries like this:
         * from m in CodeBase.FilteredMethod()  select m
         **/ 
        public static List<IMethod> FilteredMethods(this ICodeBase codebase,int a)
        {
            //return some methods
           
            return new List<IMethod>() ;
        }

        /*
         * You can also define an entire rule using an extension. 
         * And it could be used in the cqlinq queries like this:
         * warnif count >0 from m in CodeBase.MyCustomRule()  select m
         **/
        public static List<IMethod> MyCustomRule(this ICodeBase codebase, int a)
        {
            //implement the rule logic.

            return new List<IMethod>();
        }


    }
}
